#ifndef RT_DX11_GPU_H
#define RT_DX11_GPU_H

#include <wrl.h>
#include <d3d11.h>
#include <d3d11_1.h>
#include <dxgi1_3.h>

// Smart pointer for COM-Objects
template<typename T>
using ComPtr = Microsoft::WRL::ComPtr<T>;

struct rt_swap_chain {
    ComPtr<IDXGISwapChain1> swap_chain;
    ComPtr<ID3D11RenderTargetView> rtv;
};

struct rt_gpu {
    ComPtr<ID3D11Device1> device;
    ComPtr<ID3D11DeviceContext1> device_context;
    ComPtr<IDXGIFactory2> dxgi_factory;

    rt_swap_chain swap_chain;

    D3D_FEATURE_LEVEL feature_level;
};

#ifndef DONT_DEFINE_GPU_GLOBAL
extern rt_gpu g_gpu;
#endif

#endif